;; © Idiomdrottning, 2022. BSD 1-clause, see COPYING for details
(module define-er-syntax
(define-er-syntax*)
(import scheme (chicken base) (chicken syntax) matchable quasiwalk)

(define-syntax define-er-syntax*
  (ir-macro-transformer
   (lambda (e i c)
     (let ((cand (caadr e)))
       `(define-syntax ,(if (pair? cand) (car cand) cand)
          (er-macro-transformer
           (lambda (exp ,(i 'rename) ,(i 'compare))
	     (let* ((excepted (gensym))
		    (,(i 'except) (lambda (x) (vector excepted x)))
		    (excepted? (lambda (x)
				 (and (vector? x)
				      (eq? excepted (vector-ref x 0)))))
		    (,(i 'ir)
		     (lambda (tree)
		       (quasiwalk
			(lambda (x)
			  (if (excepted? x)
			      (vector-ref x 1)
			      (,(i 'rename) x)))
			tree))))
	       (match exp
		 ,@(if (pair? cand) (cdr e) (list (cdr e)))))))))))))

